#debuginfo not supported with Go
%global debug_package %{nil}
%global package_name openshift-serverless-clients
%global product_name OpenShift Serverless
%global golang_version 1.20
%global kn_version 1.10.0
%global kn_release 3
%global kn_cli_version v%{kn_version}
%global kn_major_version %{kn_cli_version:v%.1s}
%global kn_event_image registry.redhat.io/openshift-serverless-1-tech-preview/knative-client-plugin-event-sender-rhel8@sha256:81983437cfbe05cc1cc13e98a91937d6e4bdba6cd40b1cdcf9a4ed3da4bbea84
%global kn_func_util_image registry.redhat.io/openshift-serverless-1/func-utils-rhel8@sha256:61ff3f22c1c4cda4af6513da52ca3e818e88b96cc07eb015ea22dc95dce682f8
%global source_dir knative-client
%global source_tar %{source_dir}-%{kn_version}-%{kn_release}.tar.gz

Name:           %{package_name}
Version:        %{kn_version}
Release:        %{kn_release}%{?dist}
Summary:        %{product_name} client kn CLI binary
License:        ASL 2.0

URL:            https://github.com/openshift-knative/client/tree/release-%{kn_major_version}

Source0:        %{source_tar}
BuildRequires:  golang >= %{golang_version}
BuildRequires:  gcc
Provides:       %{package_name}
Obsoletes:      %{package_name} < %{kn_version}

%description
Client kn provides developer experience to work with Knative Serving APIs.

%prep
%setup -q -n %{source_dir}
# Replace CGO_ENABLED=0 with CGO_ENABLED=1 in build.sh
sed -i.bak 's/CGO_ENABLED=0/CGO_ENABLED=1/g' ./hack/build.sh && rm -f ./hack/build.sh.bak
# Replace CGO_ENABLED=0 with CGO_ENABLED=1 in release.sh
sed -i.bak 's/CGO_ENABLED=0/CGO_ENABLED=1/g' ./hack/release.sh && rm -f ./hack/release.sh.bak
# Replace CGO_ENABLED=0 with CGO_ENABLED=1 in Makefile
sed -i.bak 's/CGO_ENABLED=0/CGO_ENABLED=1/g' ./Makefile && rm -f ./Makefile.bak

%build
export GOEXPERIMENT=strictfipsruntime
export GOFLAGS="-tags=strictfipsruntime"
%ifarch x86_64
env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=linux GOARCH=amd64 %{?goflags}
    install -m 0755 kn kn-linux-amd64

env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=darwin GOARCH=amd64 %{?goflags}
    install -m 0755 kn kn-darwin-amd64

env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=windows GOARCH=amd64 %{?goflags} 
    install -m 0755 kn.exe kn-windows-amd64.exe
%endif

%ifarch aarch64
env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=linux GOARCH=arm64 %{?goflags}
    install -m 0755 kn kn-linux-arm64
%endif

%ifarch ppc64le
env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=linux GOARCH=ppc64le %{?goflags}
    install -m 0755 kn kn-linux-ppc64le
%endif

%ifarch s390x
env TAG=%{kn_cli_version} \
    KN_PLUGIN_EVENT_SENDER_IMAGE=%{kn_event_image} \
    KN_PLUGIN_FUNC_UTIL_IMAGE=%{kn_func_util_image} \
    make build-with-platform GOOS=linux GOARCH=s390x %{?goflags}
    install -m 0755 kn kn-linux-s390x
%endif

%install
mkdir -p %{buildroot}/%{_bindir}
install -m 0755 kn-linux-$(go env GOARCH) %{buildroot}/%{_bindir}/kn

%ifarch x86_64
install -d %{buildroot}%{_datadir}/%{name}-redistributable/{linux,macos,windows}
install -p -m 755 kn-linux-amd64 %{buildroot}%{_datadir}/%{name}-redistributable/linux/kn-linux-amd64
install -p -m 755 kn-darwin-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/macos/kn-darwin-amd64
install -p -m 755 kn-windows-amd64.exe %{buildroot}/%{_datadir}/%{name}-redistributable/windows/kn-windows-amd64.exe
%endif

%files
%license LICENSE
%{_bindir}/kn

%ifarch x86_64
%package redistributable
Summary:        %{product_name} client CLI binaries for Linux, macOS and Windows
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}-redistributable
Obsoletes:      %{package_name} < %{kn_version}

%description redistributable
%{product_name} client kn cross platform binaries for Linux, macOS and Windows.

%files redistributable
%license LICENSE
%dir %{_datadir}/%{name}-redistributable/linux/
%dir %{_datadir}/%{name}-redistributable/macos/
%dir %{_datadir}/%{name}-redistributable/windows/
%{_datadir}/%{name}-redistributable/linux/kn-linux-amd64
%{_datadir}/%{name}-redistributable/macos/kn-darwin-amd64
%{_datadir}/%{name}-redistributable/windows/kn-windows-amd64.exe
%endif

%changelog
* Thu Oct 5 2023 David Simansky <dsimansk@redhat.com> v1.10.0-1
- Bump kn release v1.10.0

* Tue Jul 11 2023 David Simansky <dsimansk@redhat.com> v1.9.2-1
- Bump kn release v1.9.2

* Fri Apr 28 2023 David Simansky <dsimansk@redhat.com> v1.8.1-1
- Bump kn release v1.8.1

* Tue Feb 28 2023 David Simansky <dsimansk@redhat.com> v1.7.1-1
- Bump kn release v1.7.1

* Fri Dec 9 2022 David Simansky <dsimansk@redhat.com> v1.6.1-1
- Bump kn release v1.6.1

* Fri Oct 21 2022 David Simansky <dsimansk@redhat.com> v1.5.0-1
- Bump kn release v1.5.0

* Mon Sep 12 2022 David Simansky <dsimansk@redhat.com> v1.4.1-1
- Bump kn release v1.4.1

* Fri Jul 1 2022 David Simansky <dsimansk@redhat.com> v1.3.1-1
- Bump kn release v1.3.1

* Thu May 12 2022 David Simansky <dsimansk@redhat.com> v1.2.0-1
- Bump kn release v1.2.0

* Tue Mar 29 2022 David Simansky <dsimansk@redhat.com> v1.1.0-1
- Bump kn release v1.1.0

* Thu Feb 17 2022 David Simansky <dsimansk@redhat.com> v1.0.0-1
- Bump kn release v1.0.0

* Thu Nov 18 2021 David Simansky <dsimansk@redhat.com> v0.26.0-1
- Bump kn release v0.26.0

* Tue Nov 2 2021 David Simansky <dsimansk@redhat.com> v0.25.1-1
- Bump kn release v0.25.1

* Mon Sep 13 2021 David Simansky <dsimansk@redhat.com> v0.24.0-1
- Bump kn release v0.24.0

* Mon Aug 2 2021 David Simansky <dsimansk@redhat.com> v0.23.2-1
- Bump kn release v0.23.2

* Wed Jun 16 2021 David Simansky <dsimansk@redhat.com> v0.22.0-1
- Bump kn release v0.22.0

* Thu May 6 2021 David Simansky <dsimansk@redhat.com> v0.21.0-1
- Bump kn release v0.21.0

* Thu Mar 4 2021 David Simansky <dsimansk@redhat.com> v0.20.0-1
- Bump kn release v0.20.0

* Wed Jan 27 2021 David Simansky <dsimansk@redhat.com> v0.19.1-2
- Bump kn release v0.19.1-2

* Thu Dec 17 2020 Navid Shaikh <nshaikh@redhat.com> v0.19.1-1
- Bump kn release v0.19.1

* Wed Dec 09 2020 Navid Shaikh <nshaikh@redhat.com> v0.18.4-1
- Bump kn release v0.18.4

* Mon Oct 12 2020 Navid Shaikh <nshaikh@redhat.com> v0.17.2-1
- Bump kn release v0.17.2

* Thu Oct 8 2020 David Simansky <dsimansk@redhat.com> v0.17.1-1
- Bump kn release v0.17.1

* Wed Aug 26 2020 David Simansky <dsimansk@redhat.com> v0.16.1-1
- Bump kn release v0.16.1

* Mon Aug 17 2020 Navid Shaikh <nshaikh@redhat.com> v0.15.2-1
- Bump kn release v0.15.2

* Thu May 28 2020 David Simansky <dsimansk@redhat.com> v0.14.0-1
- Bump kn release v0.14.0

* Thu Apr 16 2020 Navid Shaikh <nshaikh@redhat.com> v0.13.2-1
- Bump kn release v0.13.2

* Mon Mar 09 2020 Navid Shaikh <nshaikh@redhat.com> v0.13.1-1
- Bump kn release v0.13.1

* Mon Mar 09 2020 Navid Shaikh <nshaikh@redhat.com> v0.12.0-1
- Bump kn release v0.12.0

* Wed Jan 22 2020 Navid Shaikh <nshaikh@redhat.com> v0.11.0-1
- Bump kn release v0.11.0

* Fri Dec 13 2019 Navid Shaikh <nshaikh@redhat.com> v0.10.0-1
- Bump kn release v0.10.0

* Fri Nov 08 2019 Navid Shaikh <nshaikh@redhat.com> v0.9.0-1
- Bump kn release v0.9.0

* Wed Aug 28 2019 Navid Shaikh <nshaikh@redhat.com> v0.2.3-1
- First tech preview release
- Uses dist macro to include the target platform in RPM name

* Mon Aug 26 2019 Navid Shaikh <nshaikh@redhat.com> v0.2.2-2
- Initial tech preview release
- Uses license abbrevation ASL 2.0 for Apache Software License 2.0
- bump the release to v0.2.2-2

* Mon Aug 26 2019 Navid Shaikh <nshaikh@redhat.com> v0.2.2-1
- Initial tech preview release
- bump the version to v0.2.2

* Tue Aug 20 2019 Navid Shaikh <nshaikh@redhat.com> v0.2.1-1
- Initial tech preview release